// 400BPSK.h: interface for the C400BPSK class.
//
//////////////////////////////////////////////////////////////////////
#if !defined(AFX_400BPSK_H__7DB55DC7_E7F9_44FB_923F_50C7AB49A5C5__INCLUDED_)
#define AFX_400BPSK_H__7DB55DC7_E7F9_44FB_923F_50C7AB49A5C5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Ao40Fec.h"

class C400BPSK  
{
public:
	C400BPSK();
	virtual ~C400BPSK();
	void InitMod(double Fs, double Fc, BOOL FEConly);
	void SetFreq(double Fs, double Fc, INT rate, INT range);
	void Calc400BPSK(double *pData, INT n);

private:
	//Functions
	void CreateNewDataBlk(BYTE* buf, BOOL fec);
	BOOL GetNextDataBit(void);
	//variables
	BOOL m_LastBit;
	BOOL m_FEConly;
	BOOL BlkAlternate;
	BOOL m_DopplerUP;
	BOOL m_BiPhzState;
	BYTE m_TXShiftReg;
	BYTE m_DataBlk[512];
	WORD CalcCRC(BYTE* buf);
	INT m_BlockContents;
	INT m_DataState;
	INT m_BitPtr;
	INT m_BytePtr;
	INT m_FECSymbols[SYMPBLOCK];
	double m_DopplerRange;
	double m_DopplerRate;
	double m_DeltaPerSecSec;
	double m_DopplerInc;
	double m_PresentPhz;
	double CreateModulation(void);
	double m_RMSConstant;
	double m_SampleFreq;
	double m_CarrierPhaseInc;
	double m_SecPerSamp;
	double m_BitTime;
	double m_time;
	//IIR stuff
	double IIRFilter1( double in );
	double IIRFilter2(double in);
	double m_W1;
	double m_IIR1_A1;
	double m_IIR1_B0;
	double m_IIR1_B1;
	double m_W2[2];
	double m_IIR2_A1;
	double m_IIR2_A2;
	double m_IIR2_B0;
	double m_IIR2_B1;
	double m_IIR2_B2;
	union uWORD{
		struct xbytes{
			BYTE lsb;
			BYTE msb;
		}bytes;
	WORD both;
	}m_uTemp;
	CAo40Fec m_FEC;
};

#endif // !defined(AFX_400BPSK_H__7DB55DC7_E7F9_44FB_923F_50C7AB49A5C5__INCLUDED_)
