// MFSKGen.h: interface for the CMFSKGen class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MFSKGEN_H__2451E6C8_A8FC_420A_9608_F10554B95ED4__INCLUDED_)
#define AFX_MFSKGEN_H__2451E6C8_A8FC_420A_9608_F10554B95ED4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define SYMBITS 4
#define SYMBOL_RATE 15.625
#define FREQ_SHIFT SYMBOL_RATE

class CMFSKInterleaver
{
   BOOL m_Table[SYMBITS][SYMBITS];
public:
   void Process(BOOL* pBits);
   void Init();
};

class CMFSKGen  
{
public:
	CMFSKGen();
	virtual ~CMFSKGen();
	void InitMFSK(INT Fs, double freq);
	BOOL CalcMFSK( double* pData , INT n);
	void SetMFSKFreq(INT Fs, double freq, INT rate, INT range, BOOL idle, BOOL rev);
private:
   int GetNextSymbol();
   void FillBuffer();
   void FECEncoder(LPCSTR code);
   void Interleave(BOOL* bits);

   static LPCSTR m_pszText;

   BOOL m_bIdle;
   BOOL m_bUSOS;
   int m_nTonesNumber;

   CList<BOOL,BOOL> m_Bits;             
   CList<BOOL,BOOL> FECReg;

   CMFSKInterleaver interleaver[10];

   LPCSTR m_pChar;

   double m_2PI;
	double m_MFSKSecPerSamp;
	double m_MFSKTime;
	double m_MFSKUpdateTime;
	double m_MFSKPeriodUpdate;
	double m_MFSKPhaseInc[16];
   double m_MFSKPhaseDelta;
};

#endif // !defined(AFX_MFSKGEN_H__2451E6C8_A8FC_420A_9608_F10554B95ED4__INCLUDED_)
