//////////////////////////////////////////////////////////////////////
// PSKGen.h: interface for the CPSKGen class.
//
//////////////////////////////////////////////////////////////////////
//SoundCard/Wavefile signal generator program
// Copyright 1999.    Moe Wheatley AE4JY  <ae4jy@mindspring.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//////////////////////////////////////////////////////////////////////
//

#if !defined(AFX_PSKGEN_H__ACB4CEA2_C356_11D2_88B9_444553540000__INCLUDED_)
#define AFX_PSKGEN_H__ACB4CEA2_C356_11D2_88B9_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#define BPSK_MODE 0				// bits 1:0 used to specify which mode to use
#define QPSK_MODE 1
#define IQPSK_MODE 2
#define CW_MODE 3

#define PSKSPD_31 0				// bits 3:2 used to specify which speed to use
#define PSKSPD_63 4
#define PSKSPD_125 8


class CPSKGen  
{
public:
	CPSKGen();
	virtual ~CPSKGen();
// PSK31 and CW generator
	void InitPSK(INT Fs, double freq, INT mode);
	BOOL CalcPSK( double* pData , INT n, double imdgn);
	void SetPSKFreq(INT Fs, double freq, INT rate, INT range, BOOL idle);

private:
	double m_IMDfreq;
	double m_SymbolRate;
	INT m_PSKSpeed;
	BOOL m_IdleOnly;
	double m_DopplerRange;
	double m_DopplerRate;
	double m_DeltaPerSecSec;
	BOOL m_DopplerUP;
	double m_DopplerInc;
// PSK31 and CW generator variables
	BOOL m_Finished;
	double m_RMSConstant;
	double m_2PI;
	double m_PSKSecPerSamp;
	double m_PSKTime;
	double m_PSKPeriodUpdate;
	double m_PSKPhaseInc;
	double m_IMDPhaseInc1;
	double m_IMDPhaseInc2;
	WORD m_TxShiftReg;
	WORD m_TxCodeWord;
	INT m_PSKmode;
	INT* m_pHead;
	INT* m_pTail;
	INT* m_pCharQueue;
	double* m_pPSKtxI;
	double* m_pPSKtxQ;
	BYTE m_PresentPhase;


// PSK31 and CW generator private functions
	void CreateTestChars(INT m_PSKmode);
	BOOL GetChar( INT* ch);
	BOOL PutChar( INT ch );
	BYTE GetNextBPSKSymbol(void);
	BYTE GetNextQPSKSymbol(void);
	BYTE GetNextCWSymbol(void);
};

#endif // !defined(AFX_PSKGEN_H__ACB4CEA2_C356_11D2_88B9_444553540000__INCLUDED_)
