// RTTYGen.h: interface for the CRTTYGen class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RTTYGEN_H__2451E6C8_A8FC_420A_9608_F10554B95ED4__INCLUDED_)
#define AFX_RTTYGEN_H__2451E6C8_A8FC_420A_9608_F10554B95ED4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define STOPBIT  0x3
#define MARKBIT  0x1
#define STARTBIT (BYTE)0x0
#define SPACEBIT (BYTE)0x0

class CRTTYGen  
{
public:
	CRTTYGen();
	virtual ~CRTTYGen();
	void InitRTTY(INT Fs, double freq);
	BOOL CalcRTTY( double* pData , INT n);
	void SetRTTYFreq(INT Fs, double freq, INT rate, INT range, BOOL idle, BOOL rev);
private:
   BOOL GetNextSymbol();
   void FillBuffer();
   void EmitChar(BYTE bits);

   static LPCSTR m_pszText;

   BOOL m_bIdle;
   BOOL m_bUSOS;

   CList<BYTE,BYTE> m_Bits;             //MARKBIT, SPACEBIT, STARTBIT, STOPBIT
   CMap<char,char,WORD,WORD> m_Encoder;  //lowbyte = character bits, highbyte= shift
   LPCSTR m_pChar;
	BYTE m_nShift;

   double m_2PI;
	double m_RTTYSecPerSamp;
	double m_RTTYTime;
	double m_RTTYUpdateTime;
	double m_RTTYPeriodUpdate;
	double m_RTTYPhaseIncH;
	double m_RTTYPhaseIncL;
   double m_RTTYPhaseDelta;
};

#endif // !defined(AFX_RTTYGEN_H__2451E6C8_A8FC_420A_9608_F10554B95ED4__INCLUDED_)
